package justfun.common.pool;

/**
 * Pool 인터페이스
 * 
 * @author 조재호
 */
public interface Pool {

	/**
	 * Pool로부터 Object를 얻는다.
	 * 
	 * @return
	 * @throws PoolException
	 */
	public abstract Object requestObject() throws PoolException;

	/**
	 * Pool에 Object를 반환한다.
	 * 
	 * @param obj
	 * @throws PoolException
	 */
	public abstract void returnObject(Object obj) throws PoolException;

	/**
	 * Pool 리소스를 해제한다.
	 * 
	 * @throws PoolException
	 */
	public abstract void destroy() throws PoolException;

	/**
	 * 로그 메시지를 출력한다.
	 * 
	 * @param msg
	 */
	public abstract void printLog(String msg);
}
