package justfun.common.pool.event;

import java.util.EventListener;

/**
 * 이벤트 리스너
 * 
 * @author 조재호
 */
public interface PoolActionListener extends EventListener {

	/**
	 * Pool이 객체를 반환할 때 호출
	 * 
	 * @param event
	 */
	public void onRequestObject(PoolActionEvent event);

	/**
	 * Pool에 객체가 반환될 때 호출
	 * 
	 * @param event
	 */
	public void onReturnObject(PoolActionEvent event);

	/**
	 * Pool에 객체가 반환된 후 호출
	 * 
	 * @param event
	 */
	public void afterReturnObject(PoolActionEvent event);

}
