/*
 * Created on 2004. 2. 4.
 *
 */
package justfun.common.pool.impl;

import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import justfun.common.pool.EventDrivenPool;
import justfun.common.pool.PoolException;

/**
 * DataSource를 사용하는 Pool
 * 
 * @author 조재호
 */
public class DSConnectionPool extends EventDrivenPool {

	private Context env;
	private DataSource source;

	public DSConnectionPool(DbInfoBean dbinfo) {
		try {
			env = (Context) new InitialContext().lookup("java:comp/env");
			source = (DataSource) env.lookup(dbinfo.getPoolname());

		}
		catch (NamingException ne) {
			throw new PoolException(ne);
		}
		catch (Exception ex) {
			throw new PoolException(ex);
		}
	}

	protected Object doRequestObject() throws PoolException {
		return requestConnection();
	}

	public Connection requestConnection() throws PoolException {
		try {
			return source.getConnection();
		}
		catch (SQLException sqle) {
			throw new PoolException(sqle);
		}
	}

	protected void doReturnObject(Object obj) throws PoolException {
		returnConnection((Connection) obj);
	}

	public void returnConnection(Connection conn) throws PoolException {
		try {
			conn.close();
		}
		catch (SQLException sqle) {
			throw new PoolException(sqle);
		}
	}

	public void printLog(String msg) {
		// TODO Auto-generated method stub
		
	}
	
	public void destroy() throws PoolException {
		try {
			env.close();
		}
		catch (NamingException ne) {
			throw new PoolException(ne);
		}
	}

}
