package justfun.common.pool.impl;

import java.sql.Connection;
import java.sql.DriverManager;
import java.util.HashMap;

import justfun.common.pool.EventDrivenPool;
import justfun.common.pool.PoolException;

/**
 * 
 * 내부적으로 Connection 요청시마다 연결.. Pool이 아님
 * 
 * @author 조재호
 */
public class FakeConnectionPool extends EventDrivenPool {

	private HashMap pMap;
	FakeConnectionPool pool;
	String poolname;

	public FakeConnectionPool(DbInfoBean bean) {
		this(bean.getPoolname(), bean.getDriver(), bean.getUrl(), bean.getUser(), bean.getPw(), bean.getConntimeout(), bean.getReqtimeout(), bean.getInitconn(), bean.getMinconn(), bean.getMaxconn());
	}

	public FakeConnectionPool(String poolname, String driver, String url, String user, String pw, String conntimeout, String reqtimeout, String initconn, String minconn, String maxconn)
			throws PoolException {
		pMap = new HashMap();
		pool = null;

		this.poolname = poolname;
		pMap.put("poolname", poolname);
		pMap.put("driver", driver);
		pMap.put("url", url);
		pMap.put("user", user);
		pMap.put("pw", pw);

		try {
			driver = (String) pMap.get("driver");
			Class.forName(driver);
		}
		catch (Exception e) {
			throw new PoolException(e.getMessage());
		}
	}

	protected Object doRequestObject() throws PoolException {
		return requestConnection();
	}

	public synchronized Connection requestConnection() throws PoolException {
		String url = (String) pMap.get("url");
		String user = (String) pMap.get("user");
		String pw = (String) pMap.get("pw");

		try {
			String driver = (String) pMap.get("driver");
			Class.forName(driver);

			return DriverManager.getConnection(url, user, pw);
		}
		catch (Exception e) {
			throw new PoolException(e.getMessage());
		}
	}

	protected void doReturnObject(Object conn) throws PoolException {
		returnConnection((Connection) conn);
	}

	public synchronized void returnConnection(Connection conn) {
		try {
			if (conn != null)
				conn.close();
		}
		catch (Exception ex) {
		}
	}

	public void printLog(String msg) {
		// TODO Auto-generated method stub
		
	}
	
	public void destroy() {
	}
}
