package justfun.common.cache.comparator;

import java.util.Comparator;

import justfun.common.cache.CacheData;

/**
 * CacheData의 최근 사용 시간으로 비교
 * 
 * @author 조재호
 */
public class CacheUseTimeComparator implements Comparator {

	public CacheUseTimeComparator() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(Object o1, Object o2) {

		// Type Check
		if (!(o1 instanceof CacheData) || !(o2 instanceof CacheData)) {
			return 0;
		}

		CacheData cache1 = (CacheData) o1;
		CacheData cache2 = (CacheData) o2;

		if (cache1.getLastAccessTime() > cache2.getLastAccessTime()) {
			return 1;
		}
		else if (cache1.getLastAccessTime() < cache2.getLastAccessTime()) {
			return -1;
		}

		return 0;
	}

}
