package justfun.common.cache.test;

import justfun.common.cache.Cache;
import justfun.common.cache.NormalCache;

/**
 * <p>
 * NormalCache를 Singleton으로 얻어오는 예제..
 * </p>
 * 
 * <pre>
 * <code>
 * public class SingletonCache {
 * 	public static Cache getCache() {
 * 		return CacheHolder.INSTANCE;
 * 	}
 * 
 * 	private static class CacheHolder {
 * 		static final Cache INSTANCE = new NormalCache();
 * 	}
 * }
 * </code>
 * </pre>
 * 
 * @author 조재호
 */
class SingletonCache {

	public static Cache getCache() {
		return CacheHolder.INSTANCE;
	}

	private static class CacheHolder {
		static final Cache INSTANCE = new NormalCache();
	}

}
