package justfun.common.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

/**
 * Collection을 다루기 위한 유틸리티
 * 
 * @author 조재호
 */
public class CollectionUtil {

	/**
	 * HashMap의 데이터를 Hashtable로 복사
	 * 
	 * @param map
	 * @return
	 */
	public static Hashtable copyToHashtable(HashMap map) {
		Hashtable table = new Hashtable();

		if (map != null) {
			String[] key = (String[]) map.keySet().toArray(new String[0]);

			String value;
			for (int i = 0; i < key.length; i++) {
				value = (map.get(key[i]) == null) ? "" : map.get(key[i]).toString();
				table.put(key[i], value);
			}
		}

		return table;
	}

	/**
	 * HashMap으로 구성된 ArrayList의 데이터를 Hashtable로 구성된 Vector로 복사
	 * 
	 * @param list
	 * @return
	 */
	public static Vector copyToHashtableVector(ArrayList list) {
		Vector vector = new Vector();

		HashMap data;
		for (int i = 0; i < list.size(); i++) {
			data = (HashMap) list.get(i);

			vector.add(copyToHashtable(data));
		}

		return vector;
	}

}
