package justfun.common.util;

import java.lang.reflect.Constructor;

/**
 * 객체를 다루기 위한 유틸리티
 * 
 * @author 조재호
 */
public class ObjectUtil {

	/**
	 * 객체를 생성한다.
	 * 
	 * @param classType :
	 *            생성할 객체의 클래스 타입
	 * @param parameterType :
	 *            클래스 생성자 파라미터 타입
	 * @param initargs :
	 *            생성자 호출 시 인자
	 * @return 생성한 객체
	 * @throws Exception
	 */
	public static Object createObject(String classType, Class[] parameterType, Object[] initargs)
			throws Exception {
		try {
			Class clazz = Class.forName(classType);
			Constructor constructor = clazz.getConstructor(parameterType);
			return constructor.newInstance(initargs);
		}
		catch (Exception ex) {
			throw ex;
		}
	}

}
