/*
 * DatabaseNode.java
 *
 */

package justfun.dao.helper.model;

import java.sql.Types;

/**
 *
 * @author 조재호
 */
public class ColumnNodeItem extends TreeNodeItem {
    
    private int type;
    private int size;
    private boolean isPrimaryKey = false;
    private boolean isForeignKey = false;
    
    public ColumnNodeItem(String name){
        super(name);
    }
    
    public ColumnNodeItem(String name, int type, int size, boolean isPK, boolean isFK){
        super(name);
        this.type = type;
        this.size = size;
        this.isPrimaryKey = isPK;
        this.isForeignKey = isFK;
    }
    
    public int getType(){
        return type;
    }
    
    public String getTypeString(){
        switch( type ){
            case Types.ARRAY: return "ARRAY";
            case Types.BIGINT: return "BIGINT";
            case Types.BINARY: return "BINARY";
            case Types.BIT: return "BIT";
            case Types.BLOB: return "BLOB";
            case Types.BOOLEAN: return "BOOLEAN";
            case Types.CHAR: return "CHAR";
            case Types.CLOB: return "CLOB";
            case Types.DATALINK: return "DATALINK";
            case Types.DATE: return "DATE";
            case Types.DECIMAL: return "DECIMAL";
            case Types.DISTINCT: return "DISTINCT";
            case Types.DOUBLE: return "DOUBLE";
            case Types.FLOAT: return "FLOAT";
            case Types.INTEGER: return "INTEGER";
            case Types.JAVA_OBJECT: return "JAVA_OBJECT";
            case Types.LONGVARBINARY: return "LONGVARBINARY";
            case Types.LONGVARCHAR: return "LONGVARCHAR";
            case Types.NULL: return "NULL";
            case Types.NUMERIC: return "NUMERIC";
            case Types.OTHER: return "OTHER";
            case Types.REAL: return "REAL";
            case Types.REF: return "REF";
            case Types.SMALLINT: return "SMALLINT";
            case Types.STRUCT: return "STRUCT";
            case Types.TIME: return "TIME";
            case Types.TIMESTAMP: return "TIMESTAMP";
            case Types.TINYINT: return "TINYINT";
            case Types.VARBINARY: return "VARBINARY";
            case Types.VARCHAR: return "VARCHAR";
        }
        return "UNKNOWN";
    }
    
    public int getSize(){
        return size;
    }
    
    public boolean isPrimaryKey(){
        return isPrimaryKey;
    }
    
    public boolean isForeignKey(){
        return isForeignKey;
    }
    
    public String toString(){
        return getName() + " - " + getTypeString() + "(" + size + ")";
    }
    
}
