/*
 * 파일 필터. JFileChooser와 같은 파일 다이얼로그에서 사용.
 *
 */

package justfun.dao.helper.model;

import java.io.File;
import javax.swing.filechooser.FileFilter;
import justfun.dao.helper.util.Utils;

/**
 *
 * @author jhcho
 */
public class CustomFileFilter extends FileFilter {
    
    private String[] extension;
    private String description;
    
    public CustomFileFilter(String extension, String description){
	this.extension = extension.split(",");
	this.description = description;
    }
    
    public boolean accept(File pathname) {
	if( pathname.isDirectory() ) return true;
	
	for( int i = extension.length-1; i >= 0; i-- ){
	    if( extension[i].trim().equalsIgnoreCase(Utils.getExtension(pathname)) ){
		return true;
	    }
	}
	return false;
    }
    
    public String getDescription() {
	return this.description;
    }
    
    
}
