/*
 * DatabaseTableModel.java
 *
 */

package justfun.dao.helper.model;

import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author jhcho
 */
public class DatabaseTableModel extends AbstractTableModel {
    private String[] columnNames = null;
    private List data = null;
    
    public void setColumnNames(String[] columnNames){
	this.columnNames = columnNames;
    }
    
    public void setData(List data){
	this.data = data;
    }
    
    public int getColumnCount() {
	if( columnNames == null ) return 0;
	return columnNames.length;
    }
    
    public int getRowCount() {
	if( data == null ) return 0;
	return data.size();
    }
    
    public String getColumnName(int col) {
	if( columnNames == null ) return null;
	return columnNames[col];
    }
    
    public Object getValueAt(int row, int col) {
	if( data == null ) return null;
	Object[] record = (Object[]) data.get(row);
	return record[col];
    }
}
