/*
 * Connection 정보 관리 다이얼로그
 *
 */

package justfun.dao.helper.ui;

import justfun.dao.helper.Session;
import justfun.dao.helper.util.Connections;
import justfun.dao.helper.util.Database;
import justfun.dao.helper.util.Logger;
import java.util.List;
import java.util.Map;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 *
 * @author jhcho
 */
public class ConnectionDialog extends javax.swing.JDialog {
    
    /** Creates new form ConnectionDialog */
    public ConnectionDialog(java.awt.Frame parent, boolean modal) {
	super(parent, modal);
	initComponents();
	
	// this.btn_apply.setEnabled(false);
	// this.btn_connect.setEnabled(false);
	// this.btn_delete.setEnabled(false);
	
	loadConnectionList();
	
	this.cb_dbms.removeAllItems();
	for( int i = 0; i < Connections.dbms.length; i++ ){
	    this.cb_dbms.addItem(Connections.dbms[i]);
	}
	
	//this.jLabel7.setVisible(false);
	//this.tb_sid.setVisible(false);
    }
    
    /**
     * Load connection list
     */
    private void loadConnectionList(){
	DefaultListModel model = new DefaultListModel();
	
	try{
	    List list = Connections.list();
	    
	    Map connection;
	    for( int i = 0; i < list.size(); i++ ){
		connection = (Map) list.get(i);
		model.addElement(connection.get("name").toString());
	    }
	    
	    this.list.setModel(model);
	}catch(Exception ex){
	    Logger.write(ex);
	}
    }
    
    /**
     * reset input values
     */
    private void reset(){
	this.tb_name.setText("");
	this.tb_user.setText("");
	this.tb_passwd.setText("");
	this.tb_host.setText("");
	this.tb_port.setText("");
	this.tb_sid.setText("");
    }
    
    /**
     * validate input values - null check
     */
    private boolean validateInput(JTextField[] tf) {
	for( int i = 0; i < tf.length; i++ ){
	    if( tf[i].getText().equals("") ){
		JOptionPane.showMessageDialog(this, tf[i].getName() + " is required", "Validation", JOptionPane.WARNING_MESSAGE);
		tf[i].requestFocus();
		return false;
	    }
	}
	return true;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        list = new javax.swing.JList();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        tb_name = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        tb_user = new javax.swing.JTextField();
        tb_host = new javax.swing.JTextField();
        tb_port = new javax.swing.JTextField();
        cb_dbms = new javax.swing.JComboBox();
        tb_passwd = new javax.swing.JPasswordField();
        btn_apply = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        tb_sid = new javax.swing.JTextField();
        btn_new = new javax.swing.JButton();
        btn_delete = new javax.swing.JButton();
        btn_close = new javax.swing.JButton();
        btn_connect = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Connection");
        setResizable(false);
        jSplitPane1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setLastDividerLocation(200);
        jPanel1.setPreferredSize(new java.awt.Dimension(200, 100));
        list.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        list.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                listValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(list);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 198, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 260, Short.MAX_VALUE)
        );
        jSplitPane1.setLeftComponent(jPanel1);

        jLabel1.setText("Connection Name");

        tb_name.setName("Connection Name");

        jLabel2.setText("User");

        jLabel3.setText("Password");

        jLabel4.setText("Host");

        jLabel5.setText("Port");

        jLabel6.setText("DBMS");

        tb_user.setName("User");

        tb_host.setName("Host");

        tb_port.setName("Port");

        cb_dbms.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "MySQL" }));
        cb_dbms.setName("DBMS");
        cb_dbms.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cb_dbmsItemStateChanged(evt);
            }
        });

        tb_passwd.setName("Password");

        btn_apply.setText("Apply");
        btn_apply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_applyActionPerformed(evt);
            }
        });

        jLabel7.setText("SID");

        tb_sid.setName("User");

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 107, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(14, 14, 14)
                        .add(tb_name, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, btn_apply)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(jLabel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                        .add(14, 14, 14)
                        .add(cb_dbms, 0, 239, Short.MAX_VALUE))
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                        .add(14, 14, 14)
                        .add(tb_host, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                        .add(14, 14, 14)
                        .add(tb_port, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                        .add(14, 14, 14)
                        .add(tb_user, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                        .add(14, 14, 14)
                        .add(tb_passwd, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE))
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 107, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 14, Short.MAX_VALUE)
                        .add(tb_sid, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 239, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(31, 31, 31)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(tb_name, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6)
                    .add(cb_dbms, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(tb_host, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel5)
                    .add(tb_port, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(tb_user, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(tb_passwd, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel7)
                    .add(tb_sid, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 13, Short.MAX_VALUE)
                .add(btn_apply)
                .addContainerGap())
        );
        jSplitPane1.setRightComponent(jPanel2);

        btn_new.setText("Add New Connection");
        btn_new.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_newActionPerformed(evt);
            }
        });

        btn_delete.setText("Delete");
        btn_delete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_deleteActionPerformed(evt);
            }
        });

        btn_close.setText("Close");
        btn_close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_closeActionPerformed(evt);
            }
        });

        btn_connect.setText("Connect");
        btn_connect.setName("Connection Dialog");
        btn_connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_connectActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 591, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(btn_new, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 199, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btn_delete)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 167, Short.MAX_VALUE)
                        .add(btn_connect)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btn_close)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btn_close)
                    .add(btn_connect)
                    .add(btn_new)
                    .add(btn_delete))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void cb_dbmsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cb_dbmsItemStateChanged
	if( evt.getItem().toString().equalsIgnoreCase("oracle") ){
	    this.jLabel7.setText("SID");
	}else {
	    this.jLabel7.setText("Database");
	}
    }//GEN-LAST:event_cb_dbmsItemStateChanged
    
    private void btn_connectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_connectActionPerformed
	if( this.list.isSelectionEmpty() ){
	    JOptionPane.showMessageDialog(this, "Select connection to connect", "Connect", JOptionPane.WARNING_MESSAGE);
	    return;
	}
	
	btn_applyActionPerformed(evt);
	
	try{
	    Map connectionInfo = Connections.get(this.list.getSelectedValue().toString());
	    Database.validateConnection(connectionInfo);
	    
	    Session session = Session.currentSession();
	    session.setAttribute(Session.KEY_CONNECTIONINFO, connectionInfo);
	    
	    ((MainFrame) getParent()).showQueryBrowserPanel();
	    btn_closeActionPerformed(evt);
	}catch(Exception ex){
	    Logger.write(ex);
	    
	    String errorMessage = ex.getMessage();
	    errorMessage += "\n\n(If you want more information, see error log.)";
	    JOptionPane.showMessageDialog(this, errorMessage, "Connection failed", JOptionPane.ERROR_MESSAGE);
	}
    }//GEN-LAST:event_btn_connectActionPerformed
    
    private void listValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_listValueChanged
	try{
	    if( !this.list.isSelectionEmpty() ){
		Map connectionInfo = Connections.get(this.list.getSelectedValue().toString());
		
		this.tb_name.setText(connectionInfo.get("name").toString());
		this.tb_user.setText(connectionInfo.get("user").toString());
		this.tb_passwd.setText(connectionInfo.get("password").toString());
		this.tb_host.setText(connectionInfo.get("host").toString());
		this.tb_port.setText(connectionInfo.get("port").toString());
		this.cb_dbms.setSelectedItem(connectionInfo.get("dbms").toString());
		
		String sid = (connectionInfo.get("sid") != null)? connectionInfo.get("sid").toString(): "";
		this.tb_sid.setText(sid);
	    }
	}catch(Exception ex){
	    Logger.write(ex);
	}
    }//GEN-LAST:event_listValueChanged
    
    private void btn_applyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_applyActionPerformed
	// Validation
	JTextField[] inputs = { this.tb_name, this.tb_user, this.tb_passwd, this.tb_host, this.tb_port };
	if( validateInput(inputs) ){
	    String name = this.tb_name.getText();
	    String user = this.tb_user.getText();
	    String password = new String(this.tb_passwd.getPassword());
	    String host = this.tb_host.getText();
	    int port = Integer.parseInt(this.tb_port.getText());
	    String dbms = this.cb_dbms.getSelectedItem().toString();
	    String sid = this.tb_sid.getText();
	    
	    try{
		if( this.list.isSelectionEmpty() ){
		    // no selected connection -> add new connection
		    Connections.add(name, user, password, host, port, dbms, sid);
		    
		    DefaultListModel model = (DefaultListModel) this.list.getModel();
		    model.addElement(name);
		    
		    if( evt.getSource() == this.btn_apply ){
			JOptionPane.showMessageDialog(this, "Connection added", "Add New Connection", JOptionPane.INFORMATION_MESSAGE);
		    }
		    this.list.setSelectedIndex(this.list.getModel().getSize()-1);
		    //reset();
		} else{
		    // selected connection exist -> update connection
		    Connections.update(this.list.getSelectedValue().toString(), name, user, password, host, port, dbms, sid);
		    
		    DefaultListModel model = (DefaultListModel) this.list.getModel();
		    model.set(this.list.getSelectedIndex(), name);
		    
		    if( evt.getSource() == this.btn_apply ){
			JOptionPane.showMessageDialog(this, "Connection updated", "Update Connection", JOptionPane.INFORMATION_MESSAGE);
		    }
		}
	    }catch(Exception ex){
		Logger.write(ex);
	    }
	}
    }//GEN-LAST:event_btn_applyActionPerformed
    
    private void btn_deleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_deleteActionPerformed
	if( this.list.isSelectionEmpty() ){
	    JOptionPane.showMessageDialog(this, "Select connection to Delete", "Delete", JOptionPane.WARNING_MESSAGE);
	    return;
	}
	
	DefaultListModel model = (DefaultListModel) this.list.getModel();
	try{
	    Connections.remove(this.list.getSelectedValue().toString());
	    model.remove(this.list.getSelectedIndex());
	    reset();
	}catch(Exception ex){
	    Logger.write(ex);
	}
    }//GEN-LAST:event_btn_deleteActionPerformed
    
    
    private void btn_newActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_newActionPerformed
	reset();
	
	this.tb_name.requestFocus();
	this.list.clearSelection();
    }//GEN-LAST:event_btn_newActionPerformed
    
    private void btn_closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_closeActionPerformed
	this.dispose();
    }//GEN-LAST:event_btn_closeActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	java.awt.EventQueue.invokeLater(new Runnable() {
	    public void run() {
		new ConnectionDialog(new javax.swing.JFrame(), true).setVisible(true);
	    }
	});
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_apply;
    private javax.swing.JButton btn_close;
    private javax.swing.JButton btn_connect;
    private javax.swing.JButton btn_delete;
    private javax.swing.JButton btn_new;
    private javax.swing.JComboBox cb_dbms;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JList list;
    private javax.swing.JTextField tb_host;
    private javax.swing.JTextField tb_name;
    private javax.swing.JPasswordField tb_passwd;
    private javax.swing.JTextField tb_port;
    private javax.swing.JTextField tb_sid;
    private javax.swing.JTextField tb_user;
    // End of variables declaration//GEN-END:variables
    
}
