/*
 * DAOEditorPanel.java
 *
 */

package justfun.dao.helper.ui;

import java.util.Iterator;
import java.util.Map;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;
import justfun.dao.helper.Session;

/**
 *
 * @author  조재호
 */
public class DAOEditorPanel extends javax.swing.JPanel {
    
    private String selectedKey, selectedValue;
    
    /** Creates new form DAOEditorPanel */
    public DAOEditorPanel() {
        initComponents();
        
        this.sqllist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        this.sqllist.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                listSelectionChanged();
            }
        });
    }
    
    public void updateModelOnCurrentSession(){
        Session session = Session.currentSession();
        Map data = (Map) session.getAttribute(Session.KEY_FILE_DATA);
        
        if( data != null ){
            DefaultTableModel model = (DefaultTableModel) this.sqllist.getModel();
            model.setRowCount(0);
            
            String key;
            for( Iterator i = data.keySet().iterator(); i.hasNext();  ){
                key = i.next().toString();
                model.addRow(new Object[]{ key, data.get(key) });
            }
        }
    }
    
    private void listSelectionChanged(){
        int row = this.sqllist.getSelectedRow();
        if( row >= 0 ){
            DefaultTableModel model = (DefaultTableModel) this.sqllist.getModel();
            this.selectedKey = model.getValueAt(row, 0).toString();
            this.selectedValue = model.getValueAt(row, 1).toString();
            
            this.sqleditor.setText(this.selectedValue);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        btn_add = new javax.swing.JButton();
        btn_modify = new javax.swing.JButton();
        btn_delete = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        sqleditor = new javax.swing.JTextArea();
        jScrollPane1 = new javax.swing.JScrollPane();
        sqllist = new javax.swing.JTable();

        jSplitPane1.setBorder(null);
        jSplitPane1.setDividerLocation(120);
        jSplitPane1.setDividerSize(3);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Edit"));
        btn_add.setText("Add");
        btn_add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_addActionPerformed(evt);
            }
        });

        btn_modify.setText("Modify");
        btn_modify.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_modifyActionPerformed(evt);
            }
        });

        btn_delete.setText("Delete");
        btn_delete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_deleteActionPerformed(evt);
            }
        });

        sqleditor.setColumns(20);
        sqleditor.setRows(4);
        sqleditor.setTabSize(4);
        jScrollPane2.setViewportView(sqleditor);

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(btn_modify, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(btn_add, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(btn_delete, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(btn_add)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btn_modify)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btn_delete)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 91, Short.MAX_VALUE)
        );
        jSplitPane1.setTopComponent(jPanel1);

        sqllist.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "Value"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(sqllist);

        jSplitPane1.setRightComponent(jScrollPane1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 631, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 502, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btn_deleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_deleteActionPerformed
        if( this.selectedKey != null ){
            DefaultTableModel model = (DefaultTableModel) this.sqllist.getModel();
            model.removeRow(this.sqllist.getSelectedRow());
            
            Session session = Session.currentSession();
            Map data = (Map) session.getAttribute(Session.KEY_FILE_DATA);
            data.remove(this.selectedKey);
        }
    }//GEN-LAST:event_btn_deleteActionPerformed
    
    private void btn_modifyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_modifyActionPerformed
        if( this.selectedKey != null ){
            String value = this.sqleditor.getText();
            
            DefaultTableModel model = (DefaultTableModel) this.sqllist.getModel();
            model.setValueAt(value, this.sqllist.getSelectedRow(), 1);
            
            Session session = Session.currentSession();
            Map data = (Map) session.getAttribute(Session.KEY_FILE_DATA);
            data.put(this.selectedKey, value);
        }
    }//GEN-LAST:event_btn_modifyActionPerformed
    
    private void btn_addActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_addActionPerformed
        String key = JOptionPane.showInputDialog(this, "Input ID", "Input", JOptionPane.INFORMATION_MESSAGE);
        if( key != null ){
            Session session = Session.currentSession();
            Map data = (Map) session.getAttribute(Session.KEY_FILE_DATA);
            if( data.containsKey(key) ){
                JOptionPane.showMessageDialog(this, "\"" + key + "\" is already exist.", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            String value = this.sqleditor.getText();
            
            DefaultTableModel model = (DefaultTableModel) this.sqllist.getModel();
            model.addRow(new Object[]{ key, value });
            data.put(key, value);
        }
    }//GEN-LAST:event_btn_addActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_add;
    private javax.swing.JButton btn_delete;
    private javax.swing.JButton btn_modify;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextArea sqleditor;
    private javax.swing.JTable sqllist;
    // End of variables declaration//GEN-END:variables
    
}
