/*
 * 메인 윈도우
 *
 */

package justfun.dao.helper.ui;

import javax.swing.JFileChooser;
import justfun.dao.helper.util.Config;
import justfun.dao.helper.util.Logger;
import java.awt.Component;
import java.awt.Dimension;
import java.io.File;
import java.util.Map;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import justfun.dao.helper.Session;
import justfun.dao.helper.util.QueryLoader;
import justfun.dao.helper.util.Utils;

/**
 *
 * @author  jhcho
 */
public class MainFrame extends javax.swing.JFrame {
    
    private DAOEditorPanel editorPanel = new DAOEditorPanel();
    private QueryBrowserPanel queryBrowserPanel = new QueryBrowserPanel();
    
    /** Creates new form Main */
    public MainFrame() {
        initComponents();
        initApplication();
        
        Logger.write("Justfun DAO Helper Launched...");
    }
    
    /** 어플리케이션 초기화 */
    private void initApplication(){
        Config.initialize();
        setTitle("");
        this.m_save.setEnabled(false);
        
        showEditorPanel();
    }
    
    public void showEditorPanel(){
        this.editorPanel.updateModelOnCurrentSession();
        this.childPanel.removeAll();
        this.editorPanel.setSize(this.childPanel.getSize());
        this.childPanel.add(this.editorPanel);
        this.childPanel.updateUI();
    }
    
    public void showQueryBrowserPanel(){
        this.queryBrowserPanel.updateModelOnCurrentSession();
        this.childPanel.removeAll();
        this.queryBrowserPanel.setSize(this.childPanel.getSize());
        this.childPanel.add(this.queryBrowserPanel);
        this.childPanel.updateUI();
        
        /*
        if( Session.currentSession().getAttribute(Session.KEY_CONNECTIONINFO) == null ){
            JDialog connectionDialog = new ConnectionDialog(this, true);
            connectionDialog.setVisible(true);
        }
         */
    }
    
    public void initChildPanel(){
        updateAllChildPanel();
        this.childPanel.removeAll();
        this.childPanel.updateUI();
    }
    
    private void updateAllChildPanel(){
        this.queryBrowserPanel.updateModelOnCurrentSession();
    }
    
    /** Override Method */
    public void setTitle(String title) {
        super.setTitle("Justfun DAO Helper " + title);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        childPanel = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        m_file = new javax.swing.JMenu();
        m_new = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        m_open = new javax.swing.JMenu();
        m_xmlopen = new javax.swing.JMenuItem();
        m_propopen = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        m_save = new javax.swing.JMenuItem();
        m_saveas = new javax.swing.JMenu();
        m_xmlsave = new javax.swing.JMenuItem();
        m_propsave = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        m_exit = new javax.swing.JMenuItem();
        m_window = new javax.swing.JMenu();
        m_daoeditor = new javax.swing.JMenuItem();
        m_querybrowser = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JSeparator();
        m_preference = new javax.swing.JMenuItem();
        m_help = new javax.swing.JMenu();
        m_about = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("Main");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        org.jdesktop.layout.GroupLayout childPanelLayout = new org.jdesktop.layout.GroupLayout(childPanel);
        childPanel.setLayout(childPanelLayout);
        childPanelLayout.setHorizontalGroup(
            childPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 713, Short.MAX_VALUE)
        );
        childPanelLayout.setVerticalGroup(
            childPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 580, Short.MAX_VALUE)
        );

        m_file.setText("File");
        m_new.setText("New");
        m_new.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_newActionPerformed(evt);
            }
        });

        m_file.add(m_new);

        m_file.add(jSeparator1);

        m_open.setText("Open...");
        m_xmlopen.setText("XML");
        m_xmlopen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_xmlopenActionPerformed(evt);
            }
        });

        m_open.add(m_xmlopen);

        m_propopen.setText("Properties");
        m_propopen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_propopenActionPerformed(evt);
            }
        });

        m_open.add(m_propopen);

        m_file.add(m_open);

        m_file.add(jSeparator2);

        m_save.setText("Save");
        m_save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_saveActionPerformed(evt);
            }
        });

        m_file.add(m_save);

        m_saveas.setText("Save as...");
        m_xmlsave.setText("XML");
        m_xmlsave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_xmlsaveActionPerformed(evt);
            }
        });

        m_saveas.add(m_xmlsave);

        m_propsave.setText("Properties");
        m_propsave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_propsaveActionPerformed(evt);
            }
        });

        m_saveas.add(m_propsave);

        m_file.add(m_saveas);

        m_file.add(jSeparator3);

        m_exit.setText("Exit");
        m_exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_exitActionPerformed(evt);
            }
        });

        m_file.add(m_exit);

        jMenuBar1.add(m_file);

        m_window.setText("Window");
        m_daoeditor.setText("DAO Editor");
        m_daoeditor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_daoeditorActionPerformed(evt);
            }
        });

        m_window.add(m_daoeditor);

        m_querybrowser.setText("Query Browser");
        m_querybrowser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_querybrowserActionPerformed(evt);
            }
        });

        m_window.add(m_querybrowser);

        m_window.add(jSeparator4);

        m_preference.setText("Preference");
        m_preference.setEnabled(false);
        m_preference.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_preferenceActionPerformed(evt);
            }
        });

        m_window.add(m_preference);

        jMenuBar1.add(m_window);

        m_help.setText("Help");
        m_about.setText("About IDM");
        m_about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_aboutActionPerformed(evt);
            }
        });

        m_help.add(m_about);

        jMenuBar1.add(m_help);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(childPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(childPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void m_preferenceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_preferenceActionPerformed
        PreferenceDialog dialog = new PreferenceDialog(this, true);
        Utils.setDialogLocationToCenter(dialog);
        dialog.setVisible(true);
    }//GEN-LAST:event_m_preferenceActionPerformed
    
    private void m_xmlsaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_xmlsaveActionPerformed
        JFileChooser fc = new JFileChooser();
        if( fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION ){
            File f = fc.getSelectedFile();
            try{
                QueryLoader.storeToXml(f, (Map) Session.currentSession().getAttribute(Session.KEY_FILE_DATA));
            }catch(Exception ex){
                JOptionPane.showMessageDialog(this, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                Logger.write(ex);
            }
        }
    }//GEN-LAST:event_m_xmlsaveActionPerformed
    
    private void m_propsaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_propsaveActionPerformed
        JFileChooser fc = new JFileChooser();
        if( fc.showSaveDialog(this) == JFileChooser.APPROVE_OPTION ){
            File f = fc.getSelectedFile();
            try{
                QueryLoader.storeToProperties(f, (Map) Session.currentSession().getAttribute(Session.KEY_FILE_DATA));
            }catch(Exception ex){
                JOptionPane.showMessageDialog(this, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                Logger.write(ex);
            }
        }
    }//GEN-LAST:event_m_propsaveActionPerformed
    
    private void m_saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_saveActionPerformed
        Session session = Session.currentSession();
        if( session.getAttribute(Session.KEY_FILE_OPENED) == null ){
            this.m_xmlsave.doClick();
            return;
        }
        
        String fileType = (String) session.getAttribute(Session.KEY_FILE_TYPE);
        File file = (File) session.getAttribute(Session.KEY_FILE_OPENED);
        Map data = (Map) session.getAttribute(Session.KEY_FILE_DATA);
        
        try{
            if( "PROPERTIES".equals(session.getAttribute(Session.KEY_FILE_TYPE)) ){
                QueryLoader.storeToProperties(file, data);
            } else if ( "XML".equals(session.getAttribute(Session.KEY_FILE_TYPE)) ){
                QueryLoader.storeToXml(file, data);
            }
        }catch(Exception ex){
            JOptionPane.showMessageDialog(this, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            Logger.write(ex);
        }
    }//GEN-LAST:event_m_saveActionPerformed
    
    private void m_newActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_newActionPerformed
        Session.currentSession().clear();
        this.editorPanel.updateModelOnCurrentSession();
        this.queryBrowserPanel.updateModelOnCurrentSession();
        this.m_save.setEnabled(false);
    }//GEN-LAST:event_m_newActionPerformed
    
    private void m_xmlopenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_xmlopenActionPerformed
        JFileChooser fc = new JFileChooser();
        if( fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION ){
            File f = fc.getSelectedFile();
            try{
                Map data = QueryLoader.loadFromXml(f);
                
                Session session = Session.currentSession();
                session.setAttribute(Session.KEY_FILE_OPENED, f);
                session.setAttribute(Session.KEY_FILE_TYPE, "XML");
                session.setAttribute(Session.KEY_FILE_DATA, data);
                
                this.editorPanel.updateModelOnCurrentSession();
                this.m_save.setEnabled(true);
            }catch(Exception ex){
                JOptionPane.showMessageDialog(this, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                Logger.write(ex);
            }
        }
    }//GEN-LAST:event_m_xmlopenActionPerformed
    
    private void m_propopenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_propopenActionPerformed
        JFileChooser fc = new JFileChooser();
        if( fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION ){
            File f = fc.getSelectedFile();
            try{
                Map data = QueryLoader.loadFromProperties(f);
                
                Session session = Session.currentSession();
                session.setAttribute(Session.KEY_FILE_OPENED, f);
                session.setAttribute(Session.KEY_FILE_TYPE, "PROPERTIES");
                session.setAttribute(Session.KEY_FILE_DATA, data);
                
                this.editorPanel.updateModelOnCurrentSession();
                this.m_save.setEnabled(true);
            }catch(Exception ex){
                JOptionPane.showMessageDialog(this, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                Logger.write(ex);
            }
        }
    }//GEN-LAST:event_m_propopenActionPerformed
    
    private void m_querybrowserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_querybrowserActionPerformed
        showQueryBrowserPanel();
    }//GEN-LAST:event_m_querybrowserActionPerformed
    
    private void m_daoeditorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_daoeditorActionPerformed
        showEditorPanel();
    }//GEN-LAST:event_m_daoeditorActionPerformed
    
    private void m_aboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_aboutActionPerformed
        JDialog dialog = new AboutDialog(this, true);
        Utils.setDialogLocationToCenter(dialog);
        
        dialog.setVisible(true);
    }//GEN-LAST:event_m_aboutActionPerformed
    
    private void m_exitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_exitActionPerformed
        this.dispose();
    }//GEN-LAST:event_m_exitActionPerformed
    
    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        Component[] components = this.childPanel.getComponents();
        Dimension dim = this.childPanel.getSize();
        for( int i = 0; i < components.length; i++ ){
            components[i].setSize(dim);
        }
        this.childPanel.updateUI();
    }//GEN-LAST:event_formComponentResized
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel childPanel;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JMenuItem m_about;
    private javax.swing.JMenuItem m_daoeditor;
    private javax.swing.JMenuItem m_exit;
    private javax.swing.JMenu m_file;
    private javax.swing.JMenu m_help;
    private javax.swing.JMenuItem m_new;
    private javax.swing.JMenu m_open;
    private javax.swing.JMenuItem m_preference;
    private javax.swing.JMenuItem m_propopen;
    private javax.swing.JMenuItem m_propsave;
    private javax.swing.JMenuItem m_querybrowser;
    private javax.swing.JMenuItem m_save;
    private javax.swing.JMenu m_saveas;
    private javax.swing.JMenu m_window;
    private javax.swing.JMenuItem m_xmlopen;
    private javax.swing.JMenuItem m_xmlsave;
    // End of variables declaration//GEN-END:variables
    
}
