/*
 * UserDefinedVarDialog.java
 *
 * Created on 2006년 9월 5일 (화), 오후 9:19
 */

package justfun.dao.helper.ui;

import justfun.dao.helper.renderer.JComponentCellEditor;
import justfun.dao.helper.renderer.JComponentCellRenderer;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.swing.JLabel;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author  jhcho
 */
public class UserDefinedVarDialog extends javax.swing.JDialog {
    
    private Object tag = null;
    private Map values = null;
    
    /** Creates new form UserDefinedVarDialog */
    public UserDefinedVarDialog(java.awt.Frame parent, boolean modal) {
	super(parent, modal);
	initComponents();
	initialize();
    }
    
    public UserDefinedVarDialog(java.awt.Dialog parent, boolean modal) {
	super(parent, modal);
	initComponents();
	initialize();
    }
    
    private void initialize(){
	this.data.setDefaultRenderer(Object.class, new JComponentCellRenderer());
	this.data.getColumnModel().getColumn(0).setCellEditor(new JComponentCellEditor());
    }
    
    public void setTag(Object tag){
	this.tag = tag;
    }
    
    public Object getTag(){
	return this.tag;
    }
    
    public void setVariables(List vars){
	if( vars != null ){
	    DefaultTableModel model = (DefaultTableModel) this.data.getModel();
	    model.setRowCount(0);
	    for( int i = 0; i < vars.size(); i++ ){
		model.addRow(new Object[]{ new JLabel(vars.get(i).toString()), "" });
	    }
	    this.data.updateUI();
	}
    }
    
    public Map getValues(){
	return this.values;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        data = new javax.swing.JTable();
        btn_ok = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Input User Defined Variables");
        data.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Variable", "Value"
            }
        ));
        jScrollPane1.setViewportView(data);

        btn_ok.setText("OK");
        btn_ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_okActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(btn_ok))
            .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btn_ok))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btn_okActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_okActionPerformed
	DefaultTableModel model = (DefaultTableModel) this.data.getModel();
	int rowCount = model.getRowCount();
	this.values = new HashMap();
	for( int i = 0; i < rowCount; i++ ){
	    this.values.put(((JLabel) model.getValueAt(i, 0)).getText(), model.getValueAt(i, 1));
	}
	
	this.dispose();
    }//GEN-LAST:event_btn_okActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	java.awt.EventQueue.invokeLater(new Runnable() {
	    public void run() {
		new UserDefinedVarDialog(new javax.swing.JFrame(), true).setVisible(true);
	    }
	});
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_ok;
    private javax.swing.JTable data;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
    
}
