/*
 * Configuration 다이얼로그의 환경 설정 값들 (IDM 어플리케이션 설정)
 *
 */

package justfun.dao.helper.util;

import java.util.List;
import org.dom4j.Document;
import org.dom4j.DocumentFactory;
import org.dom4j.Element;

/**
 *
 * @author jhcho
 */
public class Configurations extends Config {
    
    /**
     * 환경 설정 값을 얻는다.
     */
    public static String getValue(String id) throws Exception {
	Document document = getDocument();
	Element root = document.getRootElement();
	if( root.element("configurations") != null ){
	    List configurations = root.element("configurations").elements("property");
	    
	    Element element;
	    for( int i = configurations.size()-1; i >= 0; i-- ){
		element = (Element) configurations.get(i);
		if( id.equals(element.attributeValue("id")) ){
		    return element.getText();
		}
	    }
	}
	return null;
    }
    
    /**
     * 값을 설정한다.
     */
    public static void setValue(String id, String value) throws Exception {
	Document document = getDocument();
	Element root = document.getRootElement();
	if( root.element("configurations") == null ){
	    root.addElement("configurations");
	}
	
	List configurations = root.element("configurations").elements("property");
	Element element = null;
	for( int i = configurations.size()-1; i >= 0; i-- ){
	    element = (Element) configurations.get(i);
	    if( id.equals(element.attributeValue("id")) ){
		break;
	    }
	    element = null;
	}
	
	if( element != null ){
	    element.setText(value);
	} else{
	    element = DocumentFactory.getInstance().createElement("property");
	    element.addAttribute("id", id);
	    element.setText(value);
	    root.element("configurations").add(element);
	}
	
	writeToXml(document);
    }
    
}
