/*
 * 로깅 처리
 *
 */

package justfun.dao.helper.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Date;
import java.text.SimpleDateFormat;

/**
 *
 * @author jhcho
 */
public class Logger {
    
    private static final String LOG_DIRECTORY = "logs";
    
    /**
     * Exception 로깅
     */
    public static void write(Throwable t){
	File logDir = new File(LOG_DIRECTORY);
	if( !logDir.exists() ){
	    logDir.mkdir();
	}
	
	Date currentTime = new Date();
	currentTime.setTime(System.currentTimeMillis());
	
	SimpleDateFormat format = new SimpleDateFormat();
	format.applyPattern("yyyy-MM-dd");
	
	File logFile = new File(logDir, "output_" + format.format(currentTime) + ".log");
	
	// PrintWriter writer = null;
	PrintStream writer = null;
	try{
	    // writer = new PrintWriter(new FileWriter(logFile, true));
	    writer = new PrintStream(new FileOutputStream(logFile, true), true, "UTF-8");
	    
	    format.applyPattern("yyyy-MM-dd HH:mm");
	    writer.println("[" + format.format(currentTime) + "] ");
	    t.printStackTrace(writer);
	} catch(Exception ex){
	} finally{
	    writer.close();
	}
	t.printStackTrace();
    }
    
    /**
     * 메시지 로깅
     */
    public static void write(String msg){
	File logDir = new File(LOG_DIRECTORY);
	if( !logDir.exists() ){
	    logDir.mkdir();
	}
	
	Date currentTime = new Date();
	currentTime.setTime(System.currentTimeMillis());
	
	SimpleDateFormat format = new SimpleDateFormat();
	format.applyPattern("yyyy-MM-dd");
	
	File logFile = new File(logDir, "output_" + format.format(currentTime) + ".log");
	
	//PrintWriter writer = null;
	PrintStream writer = null;
	try{
	    //writer = new PrintWriter(new FileWriter(logFile, true));
	    writer = new PrintStream(new FileOutputStream(logFile, true), true, "UTF-8");
	    
	    format.applyPattern("yyyy-MM-dd HH:mm");
	    writer.println("[" + format.format(currentTime) + "] " + msg);
	} catch(Exception ex){
	} finally{
	    writer.close();
	}
	System.out.println(msg);
    }
}
