package justfun.dao.webapp;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import justfun.dao.DAOManager;

/**
 * DAO Web Application 용 서블릿
 * 
 * @author 조재호
 * 
 */
public final class InitServlet extends HttpServlet {

	private void debug(String s) {
		System.out.println(s);
	}

	/**
	 * Init Servlet
	 */
	public void init(ServletConfig config) throws ServletException {
		super.init(config);

		try {
			DAOManager daoManager = DAOManager.getInstance();
			daoManager.initialize();

			debug("Initialize Complete DB Pool [ DBInitServlet.init() ] : " + daoManager);
		}
		catch (Exception ex) {
			debug(ex.toString());
		}
	}

	/**
	 * Destroy Servlet
	 */
	public void destroy() {
		try {
			/* Destroy DB Connection Pool */
			DAOManager daoManager = DAOManager.getInstance();
			daoManager.destroy();

			debug("Destroy Complete DB Pool [ DBInitServlet.destroy() ]");
		}
		catch (Exception ex) {
			debug(ex.toString());
		}
		finally {
			super.destroy();
		}
	}

}
