package justfun.framework.svc.factory;

import justfun.framework.svc.config.ServiceConfig;
import justfun.framework.svc.service.Service;

/**
 * ServiceFactory 인터페이스를 implement한 추상 서비스 팩토리 클래스. 서비스 팩토리 객체는 이 클래스를 상속한다.
 * 
 * @author 조재호
 */
public abstract class AbstractServiceFactory implements ServiceFactory {

	protected String configName;

	protected ServiceConfig config;

	public AbstractServiceFactory(String configName, ServiceConfig config) {
		this.configName = configName;
		this.config = config;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see justfun.framework.svc.factory.ServiceFactoryIF#findService(java.lang.String)
	 */
	public abstract Service findService(String serviceID) throws ServiceFactoryException;

}
