package justfun.framework.svc.service;

import justfun.framework.svc.config.ServiceConfig;

/**
 * 추상 서비스 클래스. 서비스 클래스 하나 당 비즈니스 로직이 매핑된다. 비즈니스 로직을 execute 메소드를 오버라이드 하여 구현.
 * 
 * @author 조재호
 */
public abstract class AbstractService implements Service {

	protected String serviceID;
	protected String serviceName;

	protected ServiceConfig config;

	public AbstractService(String serviceID, String serviceName, ServiceConfig config) {
		this.serviceID = serviceID;
		this.serviceName = serviceName;
		this.config = config;
	}

	public String getServiceID() {
		return serviceID;
	}

	public String getServiceName() {
		return serviceName;
	}

	public abstract ServiceParameter execute(ServiceParameter input) throws ServiceException;
}
