package justfun.framework.svc.service;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * 동적 빈 - HashMap을 사용한 동적 파라미터 빈
 * 
 * @author 조재호
 */
public class DynaBean implements Serializable {

	protected Map dynaValues;

	public DynaBean() {
		dynaValues = new HashMap();
	}

	/**
	 * 빈에 데이터을 넣는다.
	 * 
	 * @param key
	 * @param value
	 * @return 넣은 데이터
	 */
	public Object put(Object key, Object value) {
		return dynaValues.put(key, value);
	}

	/**
	 * 빈의 데이터를 얻는다.
	 * 
	 * @param key
	 * @return 데이터
	 */
	public Object get(Object key) {
		return dynaValues.get(key);
	}

	/**
	 * 해당 key의 값이 있는지 검사한다.
	 * 
	 * @param key
	 * @return 값이 있으면 true를 리턴
	 */
	public boolean containsKey(Object key) {
		return dynaValues.containsKey(key);
	}

	public String toString() {
		return dynaValues.toString();
	}
}
