package justfun.framework.svc.service;

/**
 * 서비스 인터페이스 정의
 * 
 * @author 조재호
 */

public interface Service {

	/**
	 * 서비스의 ID를 리턴한다.
	 * 
	 * @return 서비스 ID
	 */
	public String getServiceID();

	/**
	 * 서비스의 이름을 리턴한다.
	 * 
	 * @return 서비스 이름
	 */
	public String getServiceName();

	/**
	 * 서비스를 수행한다.
	 * 
	 * @param param
	 * @return 서비스 수행 결과 생성된 Object
	 * @throws ServiceException
	 */
	public ServiceParameter execute(ServiceParameter param) throws ServiceException;

}
