/*
 * Created on 2005. 11. 24.
 *
 */
package justfun.dao.util;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Iterator;
import java.util.Properties;

public class Prop2Xml {

	public static void main(String[] args) throws Exception {
		if (args.length != 2) {
			System.out.println("[Usage] : Prop2Xml input.xml output.properties");
			System.exit(-1);
		}

		execute(args[0], args[1]);
	}

	private static void execute(String srcFile, String destFile) throws Exception {
		Properties query = new Properties();
		query.load(new FileInputStream(srcFile));

		StringBuffer output = new StringBuffer();
		output.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		output.append("\n");
		output.append("\n");
		output.append("<tinydao>\n");
		
		Iterator key = query.keySet().iterator();
		while (key.hasNext()) {
			String keyStr = key.next().toString();
			output.append("\t<sql id=\""+keyStr+"\">\n");
			output.append( "\t\t" + query.get(keyStr).toString() + "\n");
			output.append("\t</sql>\n");
		}
		output.append("</tinydao>");
		fileWrite(destFile, output.toString());
	}

	private static void fileWrite(String file, String text) throws Exception {
		Writer writer = new BufferedWriter(new FileWriter(file));
		try {
			writer.write(text);
		}
		finally {
			writer.close();
		}
	}

}
