/*
 * Created on 2005. 11. 24.
 *
 */
package justfun.dao.util;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

public class Xml2Prop {

	public static void main(String[] args) throws Exception {
		if (args.length != 2) {
			System.out.println("[Usage] : Xml2Prop input.properties output.xml");
			System.exit(-1);
		}

		execute(args[0], args[1]);
	}
	
	private static void execute(String srcFile, String destFile) throws Exception {
		Map query = new Hashtable();
		
		DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		Document document = builder.parse(new FileInputStream(srcFile));

		NodeList nodeList = document.getElementsByTagName("sql");

		String id, sql;
		for (int i = 0; i < nodeList.getLength(); i++) {
			id = nodeList.item(i).getAttributes().getNamedItem("id").getNodeValue();
			sql = nodeList.item(i).getChildNodes().item(0).getNodeValue().trim();

			query.put(id, sql);
		}

		StringBuffer output = new StringBuffer();
		Iterator key = query.keySet().iterator();
		while (key.hasNext()) {
			String keyStr = key.next().toString();
			output.append(keyStr + " = " + query.get(keyStr).toString());
			output.append("\n");
		}
		fileWrite(destFile, output.toString());
	}

	private static void fileWrite(String file, String text) throws Exception {
		Writer writer = new BufferedWriter(new FileWriter(file));
		try {
			writer.write(text);
		}
		finally {
			writer.close();
		}
	}

}
